/*	Copyright (c) 1991 Richard F. Man.  All rights reserved.
 *	man@labrea.zko.dec.com, P.O. Box 6, North Chelmsford, MA 01863
 *	tabstop=4
 *
 *	$Log: system.c%v $
 * Revision 1.1  1991/12/08  22:14:03  rfm
 * Initial revision
 *
 *
 */
#ifndef BIT
#define BIT(i)	(1 << (i))
#endif

#ifdef HC11
/*	low level controller stuff
 */
#include <io.h>

extern int stack;
void *SysGetStack(unsigned int size)
	{
	unsigned int curr;
	static unsigned int stackloc = (unsigned int)&stack - 300;

	curr = stackloc;
	stackloc -= size;
	return ((void *)curr);
	}

void SysInit()
	{
	char iodev @0xaa;
	char extdev @0xab;

	iodev = 1;
	extdev = 1;

	_io.ddrc = 0x7f;
	_io.portc = 0;
	}

void SysLEDs(int i)
	{

	_io.portc = (char)(i + 1);
	}

void SysPortb(int i, int len)
	{
	int old, new;

	_io.portb = (char)(i | BIT(7));
	len += 128;
	len *= 4;
	len += 200;
	old = _io.tcnt;
	for (;;)
		{
		new = _io.tcnt;
		if (new - old < len)
			break;
		}
	_io.portb = (char)i;
	}

#else
void *SysGetStack(unsigned int size)
	{
	void *calloc(unsigned int, unsigned int);

	return (calloc(size, 1));
	}

void SysInit()
	{
	}

void SysLEDs(int i)
	{
	}

void SysPortb(int i, int len)
	{
	}

#endif
